<template>
	<q-card flat style="min-width: 5em">
		<q-card-section class="row items-center bg-primary">
			<div class="text-h6 text-white">{{$t('room.UIsettings')}}</div>
			<q-space />
			<q-btn icon="close" flat round dense v-close-popup @click="updateRoomUISettings" />
		</q-card-section>
		<q-scroll-area style="height: calc(100% - 8em); margin-top:0em;">
			<q-card-section>
				<q-list dense>
					<q-item-label header>{{ $t('general') }}</q-item-label>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>{{ $t('room.dense') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.dense" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>{{ $t('room.alarm') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.alarm" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>{{ $t('room.nextActionTime') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-item-label>{{ $t('room.nextActionTimeMinutes') }}</q-item-label>
							<q-input dense outlined v-model="roomSettings.nextActionMinutes" />
						</q-item-section>
					</q-item>
					<q-separator :spaced="!roomSettings.dense" />
					<q-item-label header>{{ $t('room.roomLitteral') }}</q-item-label>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>{{ $t('room.roomNumber') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.roomNumber" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>{{ $t('room.facilities') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.facility" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>{{ $t('room.patient') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.patient" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>&emsp;{{ $t('room.patientPicture') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.patientPicture" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>&emsp;{{ $t('room.patientIntake') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.patientIntake" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>&emsp;{{ $t('room.patientVitals') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.vitals" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>&emsp;&emsp;{{ $t('room.patientheartRate') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.heartRate" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>&emsp;&emsp;{{ $t('room.patientBp') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.bp" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>&emsp;&emsp;{{ $t('room.saturation') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.saturation" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>&emsp;{{ $t('room.vegi') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.vegi" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>&emsp;{{ $t('room.vegan') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.vegan" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>{{ $t('room.actions') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-toggle color="blue" v-model="roomSettings.actions" />
						</q-item-section>
					</q-item>

					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>{{ $t('room.heartRateLimits') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-item-label>{{ $t('room.heartRateLimitsUpper') }}</q-item-label>
							<q-input dense outlined v-model="roomSettings.hearRate_upper" />
							<q-item-label>{{ $t('room.heartRateLimitsLower') }}</q-item-label>
							<q-input dense outlined v-model="roomSettings.hearRate_lower" />
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>{{ $t('room.bpLimits') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-item-label>{{ $t('room.bpLimitsLabelUpper') }}</q-item-label>
							<div class="text-center">
								<q-input dense outlined v-model="roomSettings.bp_upper_1" />/
								<q-input dense outlined v-model="roomSettings.bp_upper_2" />
							</div>
							<q-item-label>{{ $t('room.bpLimitsLabelLower') }}</q-item-label>
							<div class="text-center">
								<q-input dense outlined v-model="roomSettings.bp_lower_1" />/
								<q-input dense outlined v-model="roomSettings.bp_lower_2" />
							</div>
						</q-item-section>
					</q-item>
					<q-item tag="label" v-ripple>
						<q-item-section>
							<q-item-label>{{ $t('room.saturation') }}</q-item-label>
						</q-item-section>
						<q-item-section side>
							<q-item-label>{{ $t('room.saturationUpper') }}</q-item-label>
							<q-input dense outlined v-model="roomSettings.saturation_upper" />
							<q-item-label>{{ $t('room.saturationLower') }}</q-item-label>
							<q-input dense outlined v-model="roomSettings.saturation_lower" />
						</q-item-section>
					</q-item>
				</q-list>
			</q-card-section>
		</q-scroll-area>
		<q-card-actions align="right" class="text-white absolute-bottom bg-primary">
			<q-btn flat :label="$t('close')" v-close-popup @click="updateRoomUISettings" />
		</q-card-actions>
	</q-card>
</template>

<script>
	import { eventBus } from "../js/event.js";
	export default {
		name: "UiSettings",
		data() {
			return {
				roomSettings: {
					dense: false,
					roomNumber: true,
					facility: true,
					patient: true,
					patientPicture: true,
					patientIntake: true,
					vitals: true,
					actions: true,
					vegi: true,
					vegan: true,
					alarm: true,
					heartRate: true,
					hearRate_upper: 180,
					hearRate_lower: 50,
					bp: true,
					bp_upper_1: 200,
					bp_upper_2: 130,
					bp_lower_1: 100,
					bp_lower_2: 60,
					saturation: true,
					saturation_upper: 100,
					saturation_lower: 95,
					nextActionMinutes: 120
				}
			};
		},
		created() {
			if (this.$q.cookies.has("roomUISettings")) {
				this.roomSettings = this.$q.cookies.get("roomUISettings");
			}
		},
		methods: {
			async updateRoomUISettings() {
				this.$q.cookies.set(
					"roomUISettings",
					JSON.stringify(this.roomSettings),
					{
						expires: 365,
						path: "/"
					}
				);
				eventBus.$emit("roomUISettings", true);
			}
		}
	};
</script>
